diff -rup nginx-0.7.61/src/http/modules/ngx_http_log_module.c ./src/http/modules/ngx_http_log_module.c
--- nginx-0.7.61/src/http/modules/ngx_http_log_module.c	2009-08-24 21:38:31.000000000 +0000
+++ ./src/http/modules/ngx_http_log_module.c	2009-08-24 21:42:11.000000000 +0000
@@ -258,16 +258,18 @@ cache_time_custom(ngx_http_log_fmt_t *lo
         ngx_memcpy(log_fmt->time_custom_buf.data, timebuf, len);
         log_fmt->time_custom_sec = tp->sec;
 
-        if (log_fmt->time_custom_msec_pos != -1) {
+        if (log_fmt->time_custom_msec_pos >= 0
+         && ((size_t) log_fmt->time_custom_msec_pos >= log_fmt->time_custom_buf.len
+          || log_fmt->time_custom_buf.data[log_fmt->time_custom_msec_pos] != '$')) {
             u_char *cp = (u_char *) ngx_strchr(log_fmt->time_custom_buf.data, '$');
             if (cp == NULL)
-                log_fmt->time_custom_msec_pos = -1; /* impossible... */
+                log_fmt->time_custom_msec_pos = -1;
             else
                 log_fmt->time_custom_msec_pos = cp - log_fmt->time_custom_buf.data;
         }
     }
 
-    if (log_fmt->time_custom_msec_pos != -1)
+    if (log_fmt->time_custom_msec_pos >= 0)
         ngx_sprintf(log_fmt->time_custom_buf.data + log_fmt->time_custom_msec_pos, "%03M", tp->msec);
 }
 
@@ -842,7 +844,7 @@ buffer:
             ngx_conf_log_error(NGX_LOG_EMERG, cf, 0, "The only $ in a time_custom_format must be a $ms reference");
             return NGX_CONF_ERROR;
         }
-        log_fmt->time_custom_msec_pos = 1; /* This is adjusted later. */
+        log_fmt->time_custom_msec_pos = 0; /* This is adjusted later. */
     } else
         log_fmt->time_custom_msec_pos = -1;
 
